using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace ValutaWindowsApplication
{
	/// <summary>
	/// Summary description for opretForm.
	/// </summary>
	public class OpretForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox landBox;
		private System.Windows.Forms.TextBox isoBox;
		private System.Windows.Forms.TextBox KursBox;
		private System.Windows.Forms.TextBox logBox;
		private System.Windows.Forms.Button opretButton;

		private ValutaBeregner	beregner;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public OpretForm(ValutaBeregner	beregner)
		{
			this.beregner = beregner;
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.landBox = new System.Windows.Forms.TextBox();
			this.isoBox = new System.Windows.Forms.TextBox();
			this.KursBox = new System.Windows.Forms.TextBox();
			this.logBox = new System.Windows.Forms.TextBox();
			this.opretButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// landBox
			// 
			this.landBox.Location = new System.Drawing.Point(24, 24);
			this.landBox.Name = "landBox";
			this.landBox.TabIndex = 0;
			this.landBox.Text = "landBox";
			// 
			// isoBox
			// 
			this.isoBox.Location = new System.Drawing.Point(136, 24);
			this.isoBox.Name = "isoBox";
			this.isoBox.TabIndex = 1;
			this.isoBox.Text = "isoBox";
			// 
			// KursBox
			// 
			this.KursBox.Location = new System.Drawing.Point(248, 24);
			this.KursBox.Name = "KursBox";
			this.KursBox.TabIndex = 2;
			this.KursBox.Text = "KursBox";
			// 
			// logBox
			// 
			this.logBox.Location = new System.Drawing.Point(24, 104);
			this.logBox.Multiline = true;
			this.logBox.Name = "logBox";
			this.logBox.Size = new System.Drawing.Size(472, 136);
			this.logBox.TabIndex = 3;
			this.logBox.Text = "logBox";
			// 
			// opretButton
			// 
			this.opretButton.Location = new System.Drawing.Point(368, 24);
			this.opretButton.Name = "opretButton";
			this.opretButton.TabIndex = 4;
			this.opretButton.Text = "Opret";
			this.opretButton.Click += new System.EventHandler(this.opretButton_Click);
			// 
			// opretForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(528, 266);
			this.Controls.Add(this.opretButton);
			this.Controls.Add(this.logBox);
			this.Controls.Add(this.KursBox);
			this.Controls.Add(this.isoBox);
			this.Controls.Add(this.landBox);
			this.Name = "opretForm";
			this.Text = "opretForm";
			this.ResumeLayout(false);

		}
		#endregion

		// knap for oprettelse
		private void opretButton_Click(object sender, System.EventArgs e)
		{
			string iso = this.isoBox.Text;
			string land = this.landBox.Text;
			float kurs = 0;
			Valutakurs val = null;
			try
			{
				val = beregner[iso];	// check om findes -  man kunne ogs istedet
				// have valgt at ValutaBeregner klassen
				// istedet gav exception ved dublet
				this.logBox.Text += "\r\nFejl valuta findes allerede: "+val.ToString();
			}
			catch (System.IndexOutOfRangeException)
			{
				try
				{
					kurs = float.Parse(this.KursBox.Text.ToString());
					val = beregner.OpretValutakurs(land, iso, kurs );
					this.logBox.Text += "\r\nValuta oprettet: "+val.ToString();
					// F fremover besked om kursndringer p denne valuta
					val.ValutakursndringsEventHandler += 
						  new ValutakursndringsEvent(this.ValutakursndringsBesked);
					}
				catch(System.FormatException)		// fra float.Parse
				{
					this.logBox.Text += "\r\nFejl kurs skal vre float: "+this.landBox.Text;
					this.logBox.Text += "\r\nValuta er ikke oprettet: "+iso;
				}
				catch (FejlKursException)			// fra beregner.opret
				{
					this.logBox.Text += "\r\nFejl kurs ikke gyldig: "+iso;
					this.logBox.Text += "\r\nValuta er ikke oprettet: "+iso;
				}
			}
		}
		private void ValutakursndringsBesked(Valutakurs valutakurs, string besked)
		{
			this.logBox.Text += "\r\nBesked: "+valutakurs.ToString()+" :"+besked;
		}
	}
}
