using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace ValutaWindowsApplication
{
	/// <summary>
	/// Summary description for opretForm.
	/// </summary>
	public class OvervgForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox isoBox;
		private System.Windows.Forms.TextBox logBox;
		private System.Windows.Forms.Button overvgIsoButton;

		private ValutaBeregner	beregner;
		private System.Windows.Forms.Button overvgAlleButton;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public OvervgForm(ValutaBeregner	beregner)
		{
			this.beregner = beregner;
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.isoBox = new System.Windows.Forms.TextBox();
			this.logBox = new System.Windows.Forms.TextBox();
			this.overvgIsoButton = new System.Windows.Forms.Button();
			this.overvgAlleButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// isoBox
			// 
			this.isoBox.Location = new System.Drawing.Point(32, 24);
			this.isoBox.Name = "isoBox";
			this.isoBox.TabIndex = 1;
			this.isoBox.Text = "isoBox";
			// 
			// logBox
			// 
			this.logBox.Location = new System.Drawing.Point(24, 104);
			this.logBox.Multiline = true;
			this.logBox.Name = "logBox";
			this.logBox.Size = new System.Drawing.Size(472, 136);
			this.logBox.TabIndex = 3;
			this.logBox.Text = "logBox";
			// 
			// overvgIsoButton
			// 
			this.overvgIsoButton.Location = new System.Drawing.Point(144, 24);
			this.overvgIsoButton.Name = "overvgIsoButton";
			this.overvgIsoButton.Size = new System.Drawing.Size(104, 23);
			this.overvgIsoButton.TabIndex = 0;
			this.overvgIsoButton.Text = "Overvg iso";
			this.overvgIsoButton.Click += new System.EventHandler(this.overvgIsoButton_Click);
			// 
			// overvgAlleButton
			// 
			this.overvgAlleButton.Location = new System.Drawing.Point(256, 24);
			this.overvgAlleButton.Name = "overvgAlleButton";
			this.overvgAlleButton.Size = new System.Drawing.Size(136, 23);
			this.overvgAlleButton.TabIndex = 4;
			this.overvgAlleButton.Text = "Overvg alle valutaer";
			this.overvgAlleButton.Click += new System.EventHandler(this.overvgAlleButton_Click);
			// 
			// OvervgForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(528, 266);
			this.Controls.Add(this.overvgAlleButton);
			this.Controls.Add(this.overvgIsoButton);
			this.Controls.Add(this.logBox);
			this.Controls.Add(this.isoBox);
			this.Name = "OvervgForm";
			this.Text = "opretForm";
			this.ResumeLayout(false);

		}
		#endregion

		private void overvgIsoButton_Click(object sender, System.EventArgs e)
		{
			string iso = this.isoBox.Text;
			try
			{
				Valutakurs val = beregner[iso];
				// F fremover besked om kursndringer p denne valuta
				val.ValutakursndringsEventHandler +=
					new ValutakursndringsEvent(this.ValutakursndringsBesked);
				this.logBox.Text += "\r\nKurs: "+val.ToString()+" overvges nu";
			}
			catch (System.IndexOutOfRangeException)
			{
				this.logBox.Text += "\r\nFejl iso:"+iso+" findes ikke";
			}

		}

		private void overvgAlleButton_Click(object sender, System.EventArgs e)
		{
			// F fremover besked om alle valuta-ndringerer
			beregner.ValutakursndringsEventHandler +=
				new ValutakursndringsEvent(this.ValutakursndringsBesked);
			this.logBox.Text += "\r\nAlle kurser overvges nu";
		}

		private void ValutakursndringsBesked(Valutakurs valutakurs, string besked)
		{
			this.logBox.Text += "\r\nBesked: "+valutakurs.ToString()+" :"+besked;
		}

	}
}
